# How to contribute

Kontalk is a community project and therefore relies on contributions.       
There are several ways to contribute to Kontalk, even if you are not a
programmer. There are a lot of things to do. Really a lot.

## Reporting bugs

Like all humans, we are not perfect. As software is written by humans, it is not
perfect either. Bugs can happen. We don't have a testing team and we mainly
rely on automed tests (still covering a tiny part of the app though) and
automated crash reports. You can help by reporting issues and malfunctions
on [GitHub issue tracking system](//github.com/kontalk/androidclient/issues/new).

## Submitting patches

Pull requests are very welcome! Here a simple set of rules to make your patch
accepted more quickly:

* **It should contain just one thing/feature/fix/whatever**
* Summarize the contents of the patch in the pull request description
* Go into specific details in commit messages
* Try to squash working commits into one or more significant commits
* Use our [editorconfig](.editorconfig) rules
* Give it a `./gradlew :app:checkstyle` to be sure everything is nice

If you don't know what patch to contribute, you may start by looking at
issues labeled with [help wanted](//github.com/kontalk/androidclient/labels/help%20wanted)
or [good first issue](//github.com/kontalk/androidclient/labels/good%20first%20issue).

## Translating

Translating this awesome app is also a way of contributing. You know your mother
tongue better than anyone else and here is your chance to make Kontalk even a
better app, in your own language.
You may [create an account on our translation portal](https://translate.kontalk.org/engage/kontalk-androidclient/)
and start translating right away!

## Discuss in our forum

[Our forum](https://forum.kontalk.org/) is a place full of people sharing your
interest for Kontalk. There you will find us (the developers) and other users
that can help you discuss issues, ideas, new features.
